package com.faraphel.tasks_valider.ui.screen.task

import android.app.Activity
import android.widget.Toast
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.runtime.MutableState
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import com.faraphel.tasks_valider.connectivity.task.TaskClient
import com.faraphel.tasks_valider.connectivity.task.session.TaskSession
import com.google.gson.Gson
import com.google.gson.reflect.TypeToken


/**
 * This screen represent a session
 * @param activity the android activity
 * @param client an HTTP client that can communicate with the server
 */
@Composable
fun TaskSessionScreen(activity: Activity, client: TaskClient) {
    Text("WIP : Session Screen")

    val session = remember { mutableStateOf<TaskSession?>(null) }

    if (session.value == null)
        return Thread { refreshGroups(activity, client, session) }.start()

    Text("Session: ${session.value!!}")

    /*
    val students = remember { mutableStateOf<List<TaskGroupEntity>?>(null) }

    // title
    Text(text = "Task Group")

    // if the groups are not yet defined, refresh the list
    if (groups.value == null) {
        Thread { refreshGroups(activity, client, groups) }.start()
        return
    }

    // if the groups have already been defined, display them
    for (group in groups.value!!) {
        Text(text = group.toString())
    }
    */
}


fun refreshGroups(activity: Activity, client: TaskClient, session: MutableState<TaskSession?>) {
    val jsonParser = Gson()

    // try to obtain the list of groups
    val response = client.get("sessions/self")

    // in case of error, notify it
    if (!response.isSuccessful)
        return activity.runOnUiThread { Toast.makeText(activity, response.message, Toast.LENGTH_LONG).show() }

    // parse the list of groups
    session.value = jsonParser.fromJson(
        response.body.string(),
        object : TypeToken<TaskSession>(){}.type
    )
}